//-----------------------------------------
// LScript Item Animation template
//

@version 2.2
@warnings
@script motion
@save relative

// global values go here
gobj=nil;
create:obj
{
    // one-time initialization takes place here
    gobj=obj;
}

destroy
{
    // take care of final clean-up activities here
}

process: ma, frame, time
{
    // called each time the object's transformational values change
    myfliph=1;
    myfliphchan=GetChannel(gobj,"Layer_flip_h");
    if(myfliphchan)
    	myfliph=1 - 2*myfliphchan.value(time);
    myflipv=1;
    myflipvchan=GetChannel(gobj,"Layer_flip_v");
    if(myflipvchan)
    	myflipv=1 - 2*myflipvchan.value(time);
    myvisib=1;
    myvisibchan=GetChannel(gobj,"Layer_visibility");
    if(myvisibchan)
    	myvisib=myvisibchan.value(time);

    myswitch=1;
    myswitchchan=FindSwitch(gobj);
    if(myswitchchan)
    	myswitch=myswitchchan.value(time);

    currsca=ma.get(SCALING,time);
    newsca=<currsca.x*myfliph*myvisib*myswitch,
			currsca.y*myflipv*myvisib*myswitch,
			currsca.z*myvisib*myswitch>;
    ma.set(SCALING,newsca);
}

FindSwitchName:pitem
{
	if(pitem.genus!=MESH || pitem.null)
		return("Switch_"+pitem.name);
	mytemp=parse(":",pitem.name);
	myname="Switch_"+mytemp[mytemp.size()];
	return(myname);
}

FindSwitch:pitem
{
	mypar=pitem.parent;
	myname=FindSwitchName(pitem);
	mygroup=ChannelGroup(mypar.name);
	mychan=mygroup.firstChannel();
	fullchan=nil;
	hasswitch=0;
	while(mychan)
	{
		channame=mychan.name;
		if(channame.contains("Switch_"))
		{
			if(channame==strleft(myname,channame.size()))
				fullchan=mychan;
			hasswitch=1;
		}
		mychan=mygroup.nextChannel();
	}
	if(!fullchan && hasswitch)
	{
		fullchan=MakeEnvelope(mypar,myname,0);
	}
	return(fullchan);
}

GetChannel:pgroup,pchname
{
	mychan=pgroup.firstChannel();
	while(mychan)
	{
		if(mychan.name==pchname)
			return(mychan);
		mychan=pgroup.nextChannel();
    }
    return(nil);
}

load: what,io
{
    if(what == SCENEMODE)   // processing an ASCII scene file
    {
		if(gobj)
		{
//debug();
			myline=io.read();
			groupname=gobj.name;
			mygroup=ChannelGroup(groupname);
			while(!io.eof() && myline!="Moho_End")
			{
				if(myline==nil)
				{
					myline=io.read();
					continue;
				}
				parsed=parse("\"",myline);
				myhead=parsed[1];
				myname=parsed[2];
				if(myhead=="Moho_Switch")
				{
					myswi=Envelope(myname,CHAN_NUMBER,mygroup.name);
					myswi.persist(1);
					myswi.load();
				}
                if(myhead=="Moho_Layer")
				{
					mylyr=Envelope(myname,CHAN_NUMBER,mygroup.name);
					mylyr.persist(1);
					mylyr.load();
				}
				myline=io.read();
			}
		}
    }
}

save: what,io
{
    if(what == SCENEMODE)
    {
		if(gobj)
		{
			mygroup=ChannelGroup(gobj.name);
			mychan=gobj.firstChannel();
			while(mychan)
			{
				myname=mychan.name;
				if(strleft(myname,7)=="Switch_")
				{
					myswi=Envelope(myname,CHAN_NUMBER,mygroup.name);
					io.writeln("Moho_Switch\""+myname);
					myswi.save();
				}
                if(strleft(myname,6)=="Layer_")
				{
					mylyr=Envelope(myname,CHAN_NUMBER,mygroup.name);
					io.writeln("Moho_Layer\""+myname);
					mylyr.save();
				}
            	mychan=gobj.nextChannel();
			}
			io.writeln("Moho_End");
		}

    }
}

options
{
}

