//-----------------------------------------
// LScript Generic template
//
// Copyright 2006 Michael Green
// info@shortbutpurple.fsnet.co.uk
//

myversion=0.1;

@version 2.2
@warnings
@script generic

// global values go here
c;

gfilesuffix="anme";
gset;
st_filen=1;
st_frend=2;
st_meshn=3;
st_useob=4;
st_rende=5;
st_expre=6;
gstring;

st_keyt=1;
st_keyx=5;
st_keyy=6;
st_keyz=7;

st_obj=1;
st_par=2;
st_bon=3;
st_swi=4;
//scenehier;

gmeshcount=0;
gmeshname=nil;
glayercount=0;

generic
{
    // perform all processing here

	mydir=getdir(SCENESDIR);
    myset[st_filen]=recall("MGMohoImport"+st_filen.asStr(),mydir+"\\*."+gfilesuffix);
	myset[st_frend]=recall("MGMohoImport"+st_frend.asStr(),1);
 	myset[st_useob]=recall("MGMohoImport"+st_useob.asStr(),1);
    myset[st_meshn]=recall("MGMohoImport"+st_meshn.asStr(),mydir+"\\*."+"lwo");
    myset[st_rende]=recall("MGMohoImport"+st_rende.asStr(),1);
    myset[st_expre]=recall("MGMohoImport"+st_expre.asStr(),1);

	

    reqbegin("Moho Importer V:"+myversion);

    c[st_filen] = ctlfilename("Moho File",myset[st_filen],50,1);
    c[st_frend] = ctlcheckbox("Use Render Settings",myset[st_frend]);
    c[st_expre] = ctlcheckbox("Switch Expressions",myset[st_expre]);
    c[st_rende] = ctlcheckbox("Use filename as render prefix",myset[st_rende]);
    c[st_useob] = ctlcheckbox("Load Object",myset[st_useob]);
    c[st_meshn] = ctlfilename("MeshFile",myset[st_meshn],50,1);

	ctlactive(c[st_useob],"ActiveObj",c[st_meshn]);
	ctlrefresh(c[st_filen],"FileRefresh");
    return if !reqpost();

    // get requester control values here
    for (i=1;i<=myset.size();i++)
    {
		myset[i]=getvalue(c[i]);
	}

    reqend();

	for(i=1;i<=myset.size();i++)
	{
    	store("MGMohoImport"+i.asStr(),myset[i]);
	}

//	TestParseline(myset);
	gset=myset;
	gmeshname=myset[st_meshn];

    worked=ImportScene(myset);
    if(worked==1)
    	info("Scene Imported");
	SaveFile(gset[st_filen]);
}

ActiveObj:value
{
	return(value);
}

FileRefresh:value
{
	mysplit=split(value);
	mydir=SwapString(mysplit[2],"Scenes","Objects");
	myname=mysplit[1]+mydir+mysplit[3]+".lwo";
	setvalue(c[st_meshn],myname);
}

SaveFile:pfilename
{
	scenedir=getdir(SCENESDIR);
	mysplit=split(pfilename);
	myfile=getfile("Save "+mysplit[3]+" scene as:",mysplit[3]+".lws",scenedir,0);
	if(myfile)
		SaveSceneAs(myfile);
}

ImportScene:pset
{
	oldtime=Scene().currenttime;
	GoToFrame(0);
	myfile=ValidateScene(pset);
   	if(!myfile)
   		return(nil);

	master=split(pset[st_filen]);
	AddNull(master[3]);
	myparent=Scene().firstSelect();

	SetRender(master[3]);
	FindLine(myfile,"### static values");
	myres=StaticValues(myfile,pset);
//	GetStyles(myfile);
	FindLine(myfile,"### animated values");
	MakeCamera(myfile,myres);

	FindLine(myfile,"### layers");
	ReadLayers(myfile,myparent);

	RefreshNow();
	GoToFrame(oldtime*Scene().fps);
	visitnodes(myparent,"AddEnvServer");
	return(1);
}

AddEnvServer:parent,child
{
		SelectItem(child.id);
		StatusMsg("Applying to "+child.name);
		ApplyServer(SERVER_ITEMMOTION_H,"MGMohoEnvManagerIA");
}

ValidateScene:pset
{
	myfilename=pset[st_filen];

	if(myfilename==nil)
	{
		error("Please select a file");
		return(nil);
	}

	myfile=File(myfilename,"r");
	if(myfile==nil)
	{
		error("Please select a file");
		return(nil);
	}
	return(myfile);
}

SetRender:pname
{
	if(!gset[st_rende])
		return;
	SetPrefix("Renders",pname);
	SetPrefix("Animations",pname);
}

SetPrefix:pstring,pname
{
	mycondir=getdir(CONTENTDIR);
	mypref=Scene().rgbprefix;
	mypost=".png";
	mycom="SaveRGBPrefix ";
	mydirname="Renders";
	if(pstring=="Animations")
	{
		mypref=Scene().animfilename;
		mypost=".mov";
		mycom="SaveAnimationName ";
		mydirname="Animations";
	}

	if(mypref=="")
	{
		VerifyDir(mydirname);
		mypref=mycondir+"\\"+mydirname+"\\"+pname;//+mypost;
		if(pstring=="Animations")
    		CommandInput("SaveAnimation");
    	else
			CommandInput("SaveRGB");
	}
	else
	{
		mysplit=split(mypref);
		mypref=mysplit[1]+mysplit[2]+pname;//+mysplit[3];
	}
	mycommand=mycom+mypref;
   	CommandInput(mycommand);
}

VerifyDir:pstring
{
	mycondir=getdir(CONTENTDIR);
	mydir=matchdirs(mycondir,pstring);
   	if(!mydir)
   	{
   		chdir(mycondir);
   		mkdir(pstring);
   	}
}

//===================================================================================
//Static values

StaticValues:pfile,pset
{
	mylines[1]=pfile.read();
	index=1;
	while(mylines[index]!="### styles")
	{
		index++;
		mylines[index]=pfile.read();
	}
	if(pset[st_frend])
	{
		myparse=ParseLine(mylines[1]);	//dimensions
		myres=<myparse[2].asInt(),myparse[3].asInt(),0>;
		myparse=ParseLine(mylines[2]);	//frame_range
	 	FirstFrame(myparse[2].asInt());
		LastFrame(myparse[3].asInt());
		PreviewFirstFrame(0);
		PreviewLastFrame(myparse[3].asInt());
		myparse=ParseLine(mylines[3]);	//fps
    	FramesPerSecond(myparse[2].asInt());
		myparse=ParseLine(mylines[4]);	//back_color
		myr=myparse[2].asNum()/255;
		myg=myparse[3].asNum()/255;
		myb=myparse[4].asNum()/255;
		CommandInput("BackdropColor "+myr.asStr()+" "+
						myg.asStr()+" "+myb.asStr());
		return(myres);
	}
	return(<640,480,0>);
}

GetStyles:pfile
{
}

MakeCamera:pfile,pres
{
	mypar=Scene().firstSelect();
	AddCamera("MohoCamera");
	ParentItem(mypar.id);
	FrameSize(pres.x,pres.y);
	mycamera=Scene().firstSelect();
    mygroup=ChannelGroup(mycamera.name);
	Antialiasing(1);
	EnhancedAA();
	myline=pfile.read();  //camera_track
	mykeys=GetKeys(pfile);
	mychannel=GetChannel(mygroup,"Position.X");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
	mychannel=GetChannel(mygroup,"Position.Y");
	MakeKeys(mychannel,mykeys,st_keyy,,,,,,);
	for(i=1;i<=mykeys.size();i++)
	{
		mykeys[i][st_keyz]= 0-(mykeys[i][st_keyz]);
	}
	mychannel=GetChannel(mygroup,"Position.Z");
	MakeKeys(mychannel,mykeys,st_keyz,,,,,,);

	myline=pfile.read();  //camera_zoom
	mykeys=GetKeys(pfile);
	ZoomFactor(1.73); // Seems to match up with moho camera

	myline=pfile.read();  //camera_roll
	mykeys=GetKeys(pfile);
	for(i=1;i<=mykeys.size();i++)
	{
		mykeys[i][st_keyx]= deg(mykeys[i][st_keyx]);
	}
	mychannel=GetChannel(mygroup,"Rotation.B");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);

	myline=pfile.read();  //camera_roll
	mykeys=GetKeys(pfile);
	for(i=1;i<=mykeys.size();i++)
	{
		mykeys[i][st_keyx]= 0-deg(mykeys[i][st_keyx]);
		mykeys[i][st_keyy]= 0-deg(mykeys[i][st_keyy]);
	}
			// Heading stored AFTER Pitch
	mychannel=GetChannel(mygroup,"Rotation.H");
	MakeKeys(mychannel,mykeys,st_keyy,,,,,,);
	mychannel=GetChannel(mygroup,"Rotation.P");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
}

// End Static
// ========================================================================
// Layers

ReadLayers:pfile,ppar
{
	index=1;
	myparent=ppar;
	while(!pfile.eof())
	{
		mytemp=pfile.read();
		mylines=ParseLine(mytemp);
		if(mylines[1]=="layer_type")
		{
			mylyrtype=mylines[2].asInt();
			myobj=MakeLayer(pfile,mylyrtype,myparent);
		}
		if(mylines.size()>1 && mylines[2]=="sub-layers")
			myparent=myobj;
		if(mylines[1]=="}")
		{
			if(myparent)
				myparent=FindMeshParent(myparent);
		}
	}
}

FindMeshParent:pchild
{
	myparent=pchild.parent;
	while(myparent.genus==BONE)
	{
		myparent=myparent.parent;
	}
	return(myparent);
}

MakeLayer:pfile,plyrtype,pparent
{
	myline=pfile.read();  //{
	myline=pfile.read();  //### generic layer values
	myobj=GenericLayerValues(pfile,pparent);
	StatusMsg("Reading:"+myobj.name);

	LayerTransforms(pfile,myobj);
	ReadToEffects(pfile);
    GetLayerEffects(pfile,myobj);
    ReadToType(pfile,pobj,plyrtype);
	ReadType(pfile,myobj,plyrtype);

//	if(gset[st_expre])
		SwitchOptions(myobj);
	return(myobj);

}

//============================================================
// Generic Layer Values

GenericLayerValues:pfile,pparent
{
	myvals=ReadGenericLayerValues(pfile);
	myobj=SetGenericLayerValues(myvals);
	ParentObj(myobj,pparent,myvals);
	return(myobj);
}

ReadGenericLayerValues:pfile
{
	myline=pfile.read();
	myname=parse("\"",myline);
	myvals[1]=myname[2];

	for(i=2;i<=14;i++)
	{
		myvals[i]=ParseLine(pfile.read());        // read other settings
	}
 	mytemp=pfile.read();    // empty line

	myset[1]=myvals[1];                 						// name
	myset[2]=myvals[2][2].asInt();      						// quality
	myset[3]=<myvals[3][2].asNum(),myvals[3][3].asNum(),0>;     // origin
	myset[4]=myvals[4][2].asInt();                              // parent bone
	for(i=5;i<=10;i++)
	{                                              // visible; render only;
		myset[i]=StringToBool(myvals[i][2]);       // edit only; ScaleComp
	}                                              // rotate to follow; FaceCamera
	myset[11]=myvals[11][2].asInt();               // masking mode
	myset[12]=myvals[12][2].asInt();               // blend mode
	myset[13]=StringToBool(myvals[13][2]);         // camera immune
	myset[14]=StringToBool(myvals[5][2]);          // dof immune
	return(myset);
}

SetGenericLayerValues:pset
{
	glayercount++;
//	name=SwapString(pset[1],"-","_")+"_"+glayercount.asStr();
	name=pset[1]+"_"+glayercount.asStr(); // make layer name unique for expressions
	AddNull(name);
	myobj=Scene().firstSelect();
    PivotPosition(pset[3].x,pset[3].y,pset[3].z);
	if(pset[6])           		// render only
    	ItemVisibility(1);
    if(pset[7])                 // editor only
   		UnseenByCamera();
   	RefreshNow();
	return(myobj);
}

//===========================================================================================
// Parenting
ParentObj:pobj,pparent,pset
{
	ParentToItem(pobj,pparent);
    mybone=pparent.bone();
	if(mybone)
	{
		if(pset[4]>=0)
			ParentToBone(mybone,pset);
		else
			BoneSource(pparent.id);
	}
}

ParentToItem:pobj,pparent
{
    oldpip=SetPIP(0);
	SelectItem(pobj.id);
	ParentItem(pparent.id);
	SetPIP(oldpip);
}

ParentToBone:pbone,pset
{
	myobj=Scene().firstSelect();

	index=1;
    while(pbone && index<pset[4]+1)
    {
		pbone=pbone.next();
		index++;
	}
	mychild=AddBoneCompensator(pbone);
	SelectItem(myobj.id);

 	oldpip=SetPIP(0);
	ParentItem(mychild.id);
	SetPIP(oldpip);
}

MovePath:pobj,poffset
{
	myoffset=@poffset.x,poffset.y,poffset.z@;
	mychan=pobj.firstChannel();
	for(i=1;i<=3;i++)
	{
		mycount=mychan.keyCount;
		for(j=1;j<=mycount;j++)
		{
			mykey=mychan.keys[j];
			mychan.setKeyValue(mykey,mychan.getKeyValue(mykey)+myoffset[i]);
		}
	}
}
//===========================================================================
// Bone compensator

AddBoneCompensator:pbone
{
	bonecompname=pbone.name+"_ParentCompensation";
	mychild=HasPreviousComp(pbone);
 	if(mychild)
 		return(mychild);
 	mychild=MakeBoneComp(pbone);
	MatchParentMeshPos(mychild);
	ParentToParentBone(pbone,mychild);
	return(mychild);
}

HasPreviousComp:pbone
{
	pname=pbone.name+"_ParentCompensation";
	mychild=pbone.firstChild();
	while(mychild)
	{
		if(mychild.name==pname)
		{
 			return(mychild);
		}
		mychild=pbone.nextChild();
 	}
 	return(nil);
}

MakeBoneComp:pbone
{
	pname=pbone.name+"_ParentCompensation";
	SelectItem(pbone.id);
	AddBone(pname);
	mychild=Scene().firstSelect();
	BoneRestLength(pbone.restlength*0.01);     // make bone small
	ItemVisibility(1);        // and invisible
	return(mychild);
}

MatchParentMeshPos:pchild
{
	mypar=pchild.parent;
	mypos=mypar.getPivot(0);
	Position(0,0,0);
	Rotation(0,0,0);
	RefreshNow();
}

ParentToParentBone:pbone,pchild
{
	mypip=SetPIP(1);
	ParentItem(pbone.id);                   // parent in place to bone parent
	mypos=pchild.getPosition(0);             // set bone position etc
	myrot=pchild.getRotation(0);
	Position(mypos.x,mypos.y,mypos.z);
	Rotation(myrot.x,myrot.y,myrot.z);
	BoneRestPosition(mypos.x,mypos.y,mypos.z);
	BoneRestRotation(myrot.x,myrot.y,myrot.z);

	RefreshNow();
	SetPIP(mypip);
}

//========================================================================
// Switch options
SwitchOptions:pobj
{
	switchchan=FindSwitch(pobj);
//	if(switchchan)
//	{
//		mychan=MakeEnvelope(pobj,"Dissolve",1);
//		myvis=MakeEnvelope(pobj,"Layer_visibility",1);
//		myalp=MakeEnvelope(pobj,"Layer_alpha",1);
//		AddSwitchExp(pobj,switchchan,mychan);
//		AddSwitchPlugin(pobj,mychan);
//	}
}

FindSwitch:pitem
{
	mypar=pitem.parent;
	myname=FindSwitchName(pitem);
	mygroup=ChannelGroup(mypar.name);
	mychan=mygroup.firstChannel();
	fullchan=nil;
	hasswitch=0;
	while(mychan)
	{
		channame=mychan.name;
		if(channame.contains("Switch_"))
		{
			if(channame==strleft(myname,channame.size()))
				fullchan=mychan;
			hasswitch=1;
		}
		mychan=mygroup.nextChannel();
	}
	if(!fullchan && hasswitch)
	{
		fullchan=MakeEnvelope(mypar,myname,0);
	}
	return(fullchan);
}

FindSwitchName:pitem
{
	if(pitem.null)
		return("Switch_"+pitem.name);
	mytemp=parse(":",pitem.name);
	myname="Switch_"+mytemp[mytemp.size()];
	return(myname);
}

MakeEnvelope:pobj,penvname,pval
{
	mychan=GetChannel(pobj,penvname);
    mygroup=ChannelGroup(pobj.name);
	if(!mychan)
    	AddEnvelope(penvname);
	mychan=GetChannel(pobj,penvname);
	if(!mychan)
	{
		mychan=Envelope(penvname,CHAN_NUMBER,mygroup.name);
		mychan.persist(1);
	}
	SetKey(mychan,0,pval,CHAN_STEPPED,,,,);
	mychan=GetChannel(pobj,penvname);
	return(mychan);
}

AddSwitchExp:pobj,pswitch,pchan
{
	mypar=pobj.parent;
	drivername=mypar.name+"."+pswitch.name;
	myvisible=pobj.name+".Layer_visibility";
	myalpha=pobj.name+".Layer_alpha";
	myexp="\"Value * (1 -["+drivername+"]*["+myvisible+"]*["+myalpha+"])\"";
	myexpname="\"Switch_"+pobj.name+"\"";
	mycom="GE_CreateExpression "+myexpname+" "+myexp;
	CommandInput(mycom);
	chanid=pchan.id;
	mycom="GE_AttachExpressionID "+chanid.asStr()+myexpname;
	CommandInput(mycom);
}

AddSwitchPlugin:pobj,pchan
{
	pchanid=pchan.id;
	CommandInput("GE_SetEnvID "+pchanid.asStr()+" 0");
	RefreshNow();
	CommandInput("GE_ApplyServer ChannelHandler MGMohoSwitchCF");
	RefreshNow();
	SelectItem(pobj.id);
}

AddSwitchPlugins
{

}
// End Switch options
//==================================================================================
// Layer Transforms

LayerTransforms:pfile,pobj
{
	myline=pfile.read();  //### transforms
	mygroup=ChannelGroup(pobj.name);

	MakeTranslation(pfile,mygroup,pobj);
	MakeScale(pfile,mygroup);
	MakeRotation(pfile,mygroup);
	MakeFlip(pfile,mygroup);
	return;
}

MakeTranslation:pfile,pgroup,pobj
{
	myline=pfile.read();//translation
	mypivot=pobj.getPivot(0);

	mykeys=GetKeys(pfile);
	for(i=1;i<=mykeys.size();i++)
	{
		//X,Y moho values are offsets from pivot value, Z is reversed
		//X,Y LW values are absolutes in parent space.
        mykeys[i][st_keyx]= mykeys[i][st_keyx]+mypivot.x;
        mykeys[i][st_keyy]= mykeys[i][st_keyy]+mypivot.y;
		mykeys[i][st_keyz]= 0-(mykeys[i][st_keyz]);
	}

	mychannel=GetChannel(pgroup,"Position.X");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
	mychannel=GetChannel(pgroup,"Position.Y");
	MakeKeys(mychannel,mykeys,st_keyy,,,,,,);
	mychannel=GetChannel(pgroup,"Position.Z");
	MakeKeys(mychannel,mykeys,st_keyz,,,,,,);
	mykeys=nil;
	RefreshNow();
	MakeBonesWork(pobj);
	return;
}

MakeBonesWork:pobj
{
	mypar=pobj.parent;
	if(mypar.genus!=BONE)
	{
		mybone=mypar.bone();
		if(mybone)
		{
			mypos=pobj.getPosition(0);
			PivotPosition(mypos.x,mypos.y,mypos.z);
		}
	}
	return;
}

MakeScale:pfile,pgroup
{
	myline=pfile.read();//scale
	mykeys=GetKeys(pfile);
	mychannel=GetChannel(pgroup,"Scale.X");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
	mychannel=GetChannel(pgroup,"Scale.Y");
	MakeKeys(mychannel,mykeys,st_keyy,,,,,,);
	mychannel=GetChannel(pgroup,"Scale.Z");
	MakeKeys(mychannel,mykeys,st_keyz,,,,,,);
	return;
}

MakeRotation:pfile,pgroup
{
	myrotpair[1][1]="rotation_x";
	myrotpair[1][2]="Rotation.P";
	myrotpair[2][1]="rotation_y";
	myrotpair[2][2]="Rotation.H";
	myrotpair[3][1]="rotation_z";
	myrotpair[3][2]="Rotation.B";

	for(i=1;i<=3;i++)
	{ 
		mylines=pfile.read();//rotation_blah
		mykeys=GetKeys(pfile);
		for(j=1;j<=mykeys.size();j++)
		{
			//rotation x is reversed
			mykeys[j][st_keyx]=deg(mykeys[j][st_keyx]);
			if(i!=3)
				mykeys[j][st_keyx]= 0-(mykeys[j][st_keyx]);
		}
		mychannel=GetChannel(pgroup,myrotpair[i][2]);
		MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
	}
	return;
}

MakeFlip:pfile,pgroup
{
	myline=pfile.read();//flip_h
	mykeys=GetKeys(pfile);
	mychan=MakeEnvelope(pgroup,"Layer_flip_h",1);
	MakeKeys(mychan,mykeys,5,,CHAN_STEPPED,,,,);
	myline=pfile.read();//flip_v
	mykeys=GetKeys(pfile);
	mychan=MakeEnvelope(pgroup,"Layer_flip_v",1);
	MakeKeys(mychan,mykeys,5,,CHAN_STEPPED,,,,);
	return;
}

// End Layer Transforms
//===========================================================================
// Layer Effects

ReadToEffects:pfile
{
	mylines=ParseLine(pfile.read());
	while(mylines.size()<3 || mylines[3]!="effects") // read to layer effects
	{
		mylines=ParseLine(pfile.read());
	}
	return;
}

GetLayerEffects:pfile,pobj
{
 	myline=ParseLine(pfile.read());
 	while(myline[1]!=nil)
 	{
		myheader=myline;
		mykeys=GetKeys(pfile);
		if(myheader[1]=="alpha")
			SetDissolve(mykeys,pobj);
		else
		{
			mychan=MakeEnvelope(pobj,"Layer_"+myheader[1],1);
			MakeKeys(mychan,mykeys,5,,CHAN_STEPPED,,,,);
		}
 		myline=ParseLine(pfile.read());
	}
	return;
}

SetDissolve:pkeys,pobj
{
	SelectItem(pobj.id);
	mychan=MakeEnvelope(pobj,"Dissolve",0);
	for(i=1;i<=pkeys.size();i++)
	{
		pkeys[i][5]=1-pkeys[i][5];
	}
	MakeKeys(mychan,pkeys,5,,CHAN_TCB,,,,);
}

// End Effects
// =========================================================================
// Type

ReadToType:pfile,pobj,plyrtype
{
	myspecific[1]="mesh";
	myspecific[2]="image";
	myspecific[3]="group";
	myspecific[4]="bone";
	myspecific[5]="switch";
	myspecific[6]="particle";
	myspecific[7]="note";
	myspecific[8]="mesh3d";

	myline=ParseLine(pfile.read());
	while(myline.size()<2 || myline[2]!=myspecific[plyrtype])
	{
		myline=ParseLine(pfile.read());
	}
	return;
}

ReadType:pfile,pobj,plyrtype
{
	if(plyrtype==1)
		GetMesh(pfile,pobj);
	else if(plyrtype==2)
		GetImage(pfile);
	else if(plyrtype==3)
		GetGroup(pfile,pobj);
	else if(plyrtype==4)
		GetBones(pfile,pobj);
 	else if(plyrtype==5)
 		GetSwitch(pfile,pobj);
 	else if(plyrtype==6)
 		GetParticle(pfile,pobj);
 	else if(plyrtype==7)
 		GetNote(pfile);
 	else if(plyrtype==8)
 		Get3d(pfile);
}

//=========================================================================
// Type 1 Mesh

GetMesh:pfile,pobj  //layer type 1
{
	for(i=1;i<=11;i++) // take down to first [
 	{
 		myline[i]=pfile.read();
 	}
	ReadMeshFile();
//	ReadPoints(pfile);
//	ReadCurves(pfile);
	ReadGroups(pfile);

	mytemp=pfile.read(); // ] end of mesh
	mytemp=pfile.read(); // } end of layer
	return;
}

ReadMeshFile
{
	gmeshcount++;
	mycount=gmeshcount;
	myfile=File(gmeshname,"r");
 	if(myfile && gset[st_useob] && gmeshname)
 		ReplaceObjectLayer(mycount,gmeshname);
}

ReadPoints:pfile
{
 	mytemp=ParseLine(pfile.read()); // pointcount
 	mypcount=mytemp[2].asInt();
 	for(i=1;i<=mypcount;i++)
 	{
 		GetKeys(pfile);
 		GetKeys(pfile);
 		myline=pfile.read(); // an integer
 		myline=pfile.read(); // a boolean
 		myline=pfile.read(); // an integer
 		myline=pfile.read(); // a point id
 	}
}

ReadCurves:pfile
{
 	mytemp=ParseLine(pfile.read());     //curves
 	mycurvecount=mytemp[2].asInt();
	for(i=1;i<=mycurvecount;i++)
 	{
 		mytemp=ParseLine(pfile.read());
 		mypcount=mytemp[1].asInt();
		for(i=1;i<=mypcount;i++)
 		{
 			mytemp=pfile.read(); // point id
 			GetKeys(pfile);
 		}
 	}
}

ReadGroups:pfile
{
	mygroups=ParseLine(pfile.read());     //curves
	while(mygroups[1]!="groups")
	{
		mygroups=ParseLine(pfile.read());
	}
	for(i=1;i<=mygroups[2].asInt();i++)
	{
		myline=pfile.read();
		myline=pfile.read();
	}
}

// End Mesh
//=====================================================================
// Type 2 Image

GetImage:pfile //layer type 2
{
	for(i=1;i<=4;i++)// } end of image
	{
		mylines[i]=pfile.read();
	}
	ReadMeshFile();
	return;
}

//=====================================================================
// Type 3 Group

GetGroup:pfile,pobj  //layer type 3
{
	for(i=1;i<=4;i++)// distance sort (end of group)
	{
		mylines[i]=pfile.read();
	}
	return;
}

// =====================================================================
// Type 4 Bones

GetBones:pfile,pobj   //layer type 4
{
	for(i=1;i<=5;i++)
	{
		mylines[i]=pfile.read();
	}
	GetSkeleton(pfile,pobj);
}

GetSkeleton:pfile,pobj
{
	myline=pfile.read();  // [ opening bracket
	mylines[1]=ParseLine(pfile.read());
	mylines[2]=ParseLine(pfile.read());
	mybindingmode=mylines[1][2].asInt();// binding mode
	mybonenum=mylines[2][2].asInt();// number of bones.

	bonelist[1][1]=nil;

	for(i=1;i<=mybonenum;i++)
	{
		bonelist[i]=MakeBone(pfile,pobj,mybindingmode);
	}
	if(bonelist[1][1]!=nil)
		ReparentBones(bonelist);

	myline=pfile.read();  // last ]
}


ReparentBones:pbonelist
{
	oldpip=SetPIP(0);
	for(i=1;i<=pbonelist.size();i++)
	{
		if(pbonelist[i][2]!=nil)
		{
			mybone=pbonelist[i][1];
			myparentboneid=pbonelist[i][2];
			SelectItem(mybone.id);
			ParentItem(myparentboneid);
			RefreshNow();
		}
	}

	SetPIP(oldpip);

	for(i=1;i<=pbonelist.size();i++)
	{
		mybone=pbonelist[i][1];
		SelectItem(mybone.id);
		RecordRestPosition();
	}
}

MakeBone:pfile,pmesh,bfalloff
{
	myset=BoneSettings(pfile);
	parentid=FindParent(myset[2],pmesh);
	mygroup=GetChannelGroup(pmesh,myset[1]);
	ReadBonePos(pfile,mygroup,myset);
	ReadBoneRot(pfile,mygroup);
	ReadBoneSca(pfile,mygroup);
	mykeys=ReadBoneAnim(pfile);
	SetTCB(mygroup,1);

	return(myset[1],parentid);
}

BoneSettings:pfile
{
	myline=pfile.read();
	myset[1]=CreateBone(myline);
	mysplit=parse("\"",myline);
	mytemp=ParseLine(mysplit[mysplit.size()]);  //use -1 place since space 1 was name.
	for(i=2;i<=9;i++)
	{                           	// parentid;anglecontid;angleContStrength
		myset[i]=mytemp[i - 1].asInt();    // PosContId;PosContVal;PosContVal;
	}                               //ScaleContId;ScaleContStr
	myset[10]=StringToBool(mytemp[10 - 1]);  // Is Selected
	for(i=11;i<=14;i++)
	{                              	//restLength;BoneStrength
		myset[i]=mytemp[i - 1].asNum();    //offsetX;offsetY
	}
	myang=ParseLine(pfile.read()); 		// angle constraints
	myset[15]=StringToBool(myang[1]); 	// angle constraints on/off
	myset[16]=deg(myang[2].asNum()); 	// angle constraints in radians
	myset[17]=deg(myang[3].asNum()); 	// angle constraints in radians
	myset[18]=GetKeys(pfile);         // Bone Dynamics on/off
	mydyn=ParseLine(pfile.read());
	for(i=1;i<=3;i++)
	{
		myset[i+18]=mydyn[i].asNum(); 		// Torque force/spring/damping
	}
	BoneRestLength(myset[11]);
	BoneStrength(myset[12]);
	return(myset);
}

CreateBone:pline
{
	mytemp=parse("\"",pline);
	myname="Null";
	if(mytemp.size()==3)
	{
		myname=mytemp[2];
 	}
	AddBone(myname);
	mybone=Scene().firstSelect();
	return(mybone);
}

FindParent:pparent,pmesh
{
	parentid=nil;
	if(pparent>=0) // bone is a childbone
	{
		pmeshnum=pmesh.id - 0x10000000;
		parentid=0x40000000+pparent*0x10000+pmeshnum;
 	}
 	else
 	{
		Rotation(<90,0,0>); // parent bones are heading 90
	}
	return(parentid);
}

GetChannelGroup:pmesh,pbone
{
	mymeshgroup=ChannelGroup(pmesh.name);
	mygroup=ChannelGroup(mymeshgroup);
	while(mygroup.name!=pbone.name)
	{
		mygroup=ChannelGroup(mymeshgroup,mygroup);
	}
	return(mygroup);
}

ReadBonePos:pfile,pgroup,pset
{
	mykeys=GetKeys(pfile);           // Position
	if(pset[2]>=0)// bone is a child
		mychannel=GetChannel(pgroup,"Position.Z");
	else
		mychannel=GetChannel(pgroup,"Position.X");
	MakeKeys(mychannel,mykeys,st_keyx,pset[13],,,,,);
	mychannel=GetChannel(pgroup,"Position.Y");
	MakeKeys(mychannel,mykeys,st_keyy,pset[14],,,,,);
}

ReadBoneRot:pfile,pgroup
{
	mykeys=GetKeys(pfile); 									//Rotation
	for(j=1;j<=mykeys.size();j++)
	{
		//rotation x is reversed
		mykeys[j][st_keyx]=0-deg(mykeys[j][st_keyx]);
	}
	mychannel=GetChannel(pgroup,"Rotation.P");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
}

ReadBoneSca:pfile,pgroup
{
	mykeys=GetKeys(pfile); 									//Rotation
	mychannel=GetChannel(pgroup,"Scale.X");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
	mychannel=GetChannel(pgroup,"Scale.Y");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
	mychannel=GetChannel(pgroup,"Scale.Z");
	MakeKeys(mychannel,mykeys,st_keyx,,,,,,);
}

ReadBoneAnim:pfile
{
	for(i=1;i<=3;i++)
	{
		mykeys[i]=GetKeys(pfile);
	}
	return(mykeys);
}

// End bones
//=====================================================================
// Type 5 Switch

GetSwitch:pfile,pobj  //layer type 5
{
	for(i=1;i<=4;i++)// switch keys
	{
		myswitchset[i]=ParseLine(pfile.read());
	}
	switchkeys=GetKeys(pfile);
	MakeSwitchKeys(switchkeys,pobj);
	myline=pfile.read(); // skeleton
	GetSkeleton(pfile,pobj);
	return;
}

MakeSwitchKeys:pkeys,pobj
{
	for(i=1;i<=pkeys.size();i++)
	{
		pname=pkeys[i][5];
		channames[i]=pname;//SwapString(pname,"-","_");
	}
	channames.sortA();
	channames.reduce();
	mygroup=ChannelGroup(pobj.name);
	for(i=1;i<=channames.size();i++)
	{
		//make envelopes.
		myenvs[i]=Envelope("Switch_"+channames[i],CHAN_NUMBER,mygroup.name);
		myenvs[i].persist(1);
	}
	myfps=Scene().fps;
	for(i=1;i<=pkeys.size();i++)
	{
		mytime=pkeys[i][1]/myfps;
		myname=pkeys[i][5];//SwapString(pkeys[i][5],"-","_");
		mylayername="Switch_"+myname;
		for(j=1;j<=myenvs.size();j++)
		{
			mychan=myenvs[j];
			if(mylayername==mychan.name)
				SetKey(mychan,mytime,1,CHAN_STEPPED,,,,);
			else
				SetKey(mychan,mytime,0,CHAN_STEPPED,,,,);
		}
 	}
}

// End Switch
//===========================================================

GetParticle:pfile,pobj  //layer type 6
{
	for(i=1;i<=19;i++)// particle values
	{
		mylines[i]=pfile.read();
	}
	GetKeys(pfile);
	return;
}

GetNote:pfile  //layer type 7
{
	myline=parse("\"",pfile.read()); //Just one line.
	mytext=myline[2];
	myline=pfile.read(); // last }
	return;
}

Get3d:pfile  //layer type 8
{
	for(i=1;i<=14;i++)// down to last }
	{
		mylines[i]=pfile.read();
	}
	return;
}

// End Layer Types
//===============================================================

GetChannel:pgroup,pchname
{
	mychan=pgroup.firstChannel();
	while(mychan)
	{
		if(mychan.name==pchname)
			return(mychan);
		mychan=pgroup.nextChannel();
    }
    return(nil);
}

SetTCB:pgroup,pframe
{
	myfps=Scene().fps;
	mytime=pframe/myfps;
	mychannel=pgroup.firstChannel();
	while(mychannel)
	{
    	if(mychannel.keyExists(mytime))
    	{
			mykey=mychannel.keyExists(mytime);
			mychannel.setKeyContinuity(mykey,-1);
		}
		mychannel=pgroup.nextChannel();
	}
}

//===============================================================
// Start Keys

GetKeys:qfile
{
	mykeys=ReadKeys(qfile);
	actionkeys=ReadActions(qfile,qisstring);
	return(mykeys);
}

ReadKeys:qfile     // reads everything except the last ]
{
	isstring=0;
	myline=qfile.read();// open [
	myline=qfile.read();// keys count
	mykeystring=ParseLine(myline);
	mykeynum=mykeystring[2].asInt();
	for(i=1;i<=mykeynum;i++)
	{
		mylines[i]=qfile.read();
	}
	for(i=1;i<=mykeynum;i++)
	{
		mytemp=ParseLine(mylines[i]);
		mykeys[i][1]=mytemp[1].asNum();   // frame no
		mykeys[i][2]=mytemp[2].asNum();   // key type
		mykeys[i][3]=mytemp[3].asNum();
		mykeys[i][4]=mytemp[4].asNum();
	}
	parseline=ParseLine(mylines[1]);
	if(mylines[1].contains("\""))
		mykeys=MakeStringKeys(mykeynum,mykeys,mylines);
	else if(parseline[5]=="true" || parseline[5]=="false")
		mykeys=MakeBoolKeys(mykeynum,mykeys,mylines);
	else
		mykeys=MakeNumKeys(mykeynum,mykeys,mylines);
	return(mykeys);
}

MakeStringKeys:pkeynum,pkeys,plines
{
	for(i=1;i<=pkeynum;i++)
	{
		stringparse=parse("\"",plines[i]);
		if(stringparse.size()>1)
			pkeys[i][5]=stringparse[2];
		else
			pkeys[i][5]=nil;
	}
	return(pkeys);
}

MakeBoolKeys:pkeynum,pkeys,plines
{
	for(i=1;i<=pkeynum;i++)
	{
		parseline=ParseLine(plines[i]);
		pkeys[i][5]=StringToBool(parseline[5]);
	}
	return(pkeys);
}

MakeNumKeys:pkeynum,pkeys,plines
{
	for(i=1;i<=pkeynum;i++)
	{
		parseline=ParseLine(plines[i]);
		for(j=5;j<=parseline.size();j++)
		{
			pkeys[i][j]=parseline[j].asNum();
		}
	}
	return(pkeys);
}

// End Get keys
//======================================================================================
// Read Actions
ReadActions:qfile,qisstring  // reads the last ] or the first actions
{
	myline=ParseLine(qfile.read());// close ] or actions
	if(myline[1]=="]")
		return(nil);

	acount=myline[2].asInt();

	for(t=1;t<=acount;t++)
	{
		myactions[t]=ReadAction(qfile,qisstring);
	}
	myline=ParseLine(qfile.read());// close ]
	return(myactions);
}

ReadAction:qfile,qisstring
{

	myname=parse("\"",qfile.read());
	action[1]=myname[2];//Action name
	myline=ParseLine(qfile.read());
	while(myline[1]!="]")
	{
		myline=ParseLine(qfile.read());
	}
//	action[2]=GetKeys(qfile);
   	return(action);
}

//========================================================================================

MakeKeys:pchannel,pkeys,ppos,poffset=0,pcurve=1,pa=0,pb=0,pc=0,pd=0
{
	myfps=Scene().fps;
	for(i=1;i<=pkeys.size();i++)
	{
		keytime=pkeys[i][st_keyt]/myfps;
		keyval=pkeys[i][ppos];
		SetKey(pchannel,keytime,keyval+poffset,pcurve,,,,);
	}

	if(poffset!=0)
	{
		//reset 0 frame and add a 1 frame
		mykey=pchannel.keyExists(0);
		keyval=pchannel.getKeyValue(mykey);
		pchannel.setKeyValue(mykey,keyval-poffset);
		mykey=pchannel.keyExists(1/myfps);
		if(!mykey)
		{
			SetKey(pchannel,1/myfps,keyval,1,1,,,);
		}
	}
}

SetKey:pchan,ptime=0,pval=0,pcurve=1,pa=0,pb=0,pc=0,pd=0      //
{
	if(!pchan.keyExists(ptime))
	{
		pchan.createKey(ptime,pval);
	}
	mykey=pchan.keyExists(ptime);
	pchan.setKeyValue(mykey,pval);
	pchan.setKeyCurve(mykey,pcurve);
	if(pcurve==CHAN_TCB)
	{
		pchan.setKeyTension(mykey,pa);
		pchan.setKeyContinuity(mykey,pb);
		pchan.setKeyBias(mykey,pc);
	}
	if(pcurve==CHAN_HERMITE)
		pchan.setKeyHermite(mykey,pa,pb,pc,pd);
}

StringToBool:pstring
{
	mybool=0;
	if(pstring=="true")
		mybool=1;
	return(mybool);
}

FindLine:pfile,pline
{
	myline=pfile.read();
	while(myline!=pline)
	{
		myline=pfile.read();
	}
}

ParseLine:pstring
{
	if(pstring==nil)
	{
		mystring[1]=nil;
		return(mystring);
	}
	mysize=pstring.size();
	mystring=pstring;
	i=1;
	while(i<=mysize && pstring[i].isCntrl())
	{
    	i++;
	}
	mystring=strright(pstring,(mysize - i + 1));
	mystring=parse(" ",mystring);
	return(mystring);
}

SetPIP:ison
{
   	pipon=Scene().generalopts[3];
	if(ison!=pipon)
    {
    	ParentInPlace();
        RefreshNow();
    }
    return(pipon);
}

SwapString:pname,astring,bstring    //swap bstring for astring
{
    if(!pname.contains(astring))
        return(pname);

    mynewname="";
    j=1;
    while(j<=pname.size())
    {
        if(strsub(pname,j,astring.size())==astring)
        {
            mynewname=mynewname+bstring;
            j=j+astring.size() - 1;
        }
        else
            mynewname=mynewname+pname[j];
        j++;
    }
    return(mynewname);
}

SwapString2:pname,astring,bstring    //swap bstring for astring
{
	exp = regexp(astring,bstring);
	pname ~= exp;
	return(pname);
}
