//-----------------------------------------
// LScript Modeler template
//
// Copyright 2006 Michael Green
// info@shortbutpurple.fsnet.co.uk
//

myversion=0.1;
@version 2.2
@warnings
@script modeler

// global values go here
gfilesuffix="moho";
glayercount=0;
gset;

st_filen=1;
st_freez=2;
st_tripl=3;
st_image=4;
st_space=5;
st_sharp=6;
gstring;

st_keyt=1;
st_keyx=5;
st_keyy=6;
st_keyz=7;

st_curvesharpness=0.1;

InitStrings
{
 	gstring[st_filen]="Filen";
 	gstring[st_freez]="Freez";
 	gstring[st_tripl]="Tripl";
 	gstring[st_image]="Image";
 	gstring[st_space]="Space";
 	gstring[st_sharp]="Sharp";
}

main
{
	InitStrings();

    // requester code goes here
	mydir=getdir("Content");
    myset[st_filen]=recall("MGMohoImport"+gstring[st_filen],mydir+"\\Scenes\\*."+gfilesuffix);
    myset[st_freez]=recall("MGMohoImport"+gstring[st_freez],1);
    myset[st_tripl]=recall("MGMohoImport"+gstring[st_tripl],1);
    myset[st_image]=recall("MGMohoImport"+gstring[st_image],20);
    myset[st_space]=recall("MGMohoImport"+gstring[st_space],0.001);
    myset[st_sharp]=recall("MGMohoImport"+gstring[st_sharp],0.001);

    reqbegin("MGMohoMeshImporter V:"+myversion);

    c[st_filen] = ctlfilename("Moho File",myset[st_filen],50,1);
    c[st_freez] = ctlcheckbox("Freeze curves",myset[st_freez]);
    c[st_tripl] = ctlcheckbox("Triple",myset[st_tripl]);
    c[st_image] = ctlinteger("Image Layer Sections",myset[st_image]);
    c[st_space] = ctldistance("Layer Z separation",myset[st_space]);
    c[st_sharp] = ctlnumber("Sharpness threshold",myset[st_sharp]);

	ctlactive(c[st_freez],"PolyOpts",c[st_tripl]);
    return if !reqpost();

    // get requester control values here
    for (i=1;i<=myset.size();i++)
    {
		myset[i]=getvalue(c[i]);
	}

    reqend();

     for(i=1;i<=myset.size();i++)
	{
    	store("MGMohoImport"+gstring[i],myset[i]);
	}

   	gset=myset;
   	pfile=VerifyFile(gset[st_filen]);
   	if(!pfile)
   		return;
    result=ImportFile(myset,pfile);
    if(!result)
    	return;
    info("File loaded");
	SaveFile(gset[st_filen]);
	mylyrs=lyrdata();
	lyrsetfg(mylyrs);


}

PolyOpts:val
{
	return(val);
}

VerifyFile:filename
{
	if(filename==nil)
	{
		error("Please select a file");
		return(nil);
	}

	myfile=File(filename,"r");
	if(myfile==nil)
	{
		error("Please select a file");
		return(nil);
	}
	return(myfile);
}

SaveFile:pfilename
{
	objdir=getdir(OBJECTSDIR);
	mysplit=split(pfilename);
	myfile=getfile("Save "+mysplit[3]+" mesh as:",mysplit[3]+".lwo",objdir,0);
	if(myfile)
		save(myfile);
}

ImportFile:pset,pfile
{
	if(lyrdata())
		new();
	FindSegmentStart(pfile,"### styles",);
	ReadStyleSection(pfile);
	ImportLayers(pset,pfile);
	pfile.close();
	return(1);
}

ReadStyleSection:pfile
{
	myline=pfile.read();
	while(myline=="style")
	{
		mysurf=ReadStyle(pfile,);
		myline=FindSegmentStart(pfile,"style","### layers");
	}
}

//==========================================================================
// Style Loader

ReadStyle:pfile,pmeshname="Default"
{
	mysurf=ReadStyleName(pfile,pmeshname);
	(mycol,mytrans)=SetColour(pfile,mysurf);
	mybrush=ReadBrush(pfile);
	myeffec=ReadEffects(pfile);
	return(mysurf);
}

ReadStyleName:pfile,pmeshname
{
	mytemp=ParseLine(pfile.read());
	mytempname=parse("\"",mytemp[1]);
	myname=pmeshname;
	if(mytempname[1])
		myname=mytempname[1];
	setsurface(myname);
	mysurf=Surface(myname);
	return(mysurf);
}

SetColour:pfile,psurf
{
	fillon=ParseLine(pfile.read());
	if(fillon[1]=="false")
	{
		psurf.setValue(SURFTRAN,1);
		psurf.setValue(SURFAVAL,0);
	}

	mycol=GetKeys(pfile);
	mycolval=<255*mycol[1][5],255*mycol[1][6],255*mycol[1][7]>;
	mytransp=1-mycol[1][8];  //using an alpha value as transparency.
	psurf.setValue(SURFCOLR,mycolval);
	psurf.setValue(SURFTRAN,mytransp);
	psurf.setValue(SURFLUMI,1);
	psurf.setValue(SURFDIFF,0);
	psurf.setValue(SURFSIDE,3);
	psurf.setValue(SURFAVAL,0);
	if(mycol.size()>1)
	{
		mycommand="Surf_SetInt \"BaseColor\" 1";
		CommandInput(mycommand);
		myenv=psurf.getEnvelope(SURFCOLR);
	}
	return(mycolval,mytransp);
}

ReadBrush:pfile
{
	bwidth=1;
	blineo=2;
	bcolou=3;
	bfilen=4;
	balign=5;
	bangle=6;
	bspace=7;
	brando=8;

	brushset[bwidth]=ParseLine(pfile.read());  	// line width on, line width in ???
	brushset[blineo]=ParseLine(pfile.read());  	// Line on
	brushset[bcolou]=GetKeys(pfile);         	// Line colour
	brushset[bfilen]=ParseLine(pfile.read()); 	// Line brush filename (no path)
	brushset[balign]=ParseLine(pfile.read()); 	//Align brush with curve
	brushset[bangle]=ParseLine(pfile.read()); 	//Brush random angle limit in radians
	brushset[bspace]=ParseLine(pfile.read()); 	// Brush spacing %
	brushset[brando]=ParseLine(pfile.read()); 	// Maximise Frame to frame randomness
  	return(brushset);
}

ReadEffects:pfile
{
	for(i=1;i<=3;i++)
	{
		eff=ParseLine(pfile.read());
		if(eff[1]!="-1")
			effects[i]=ParseLine(pfile.read());
		else
			effects[i]=nil;
	}
	return(effects);
}

// Style Loader End
//==========================================================================

ImportLayers:pset,pfile
{
	pivotindex=1;
	pivotlist[pivotindex]=0;
	while(!pfile.eof())
	{
		myline=pfile.read();
		myparse=ParseLine(myline);
		if(myparse[1]=="layer_type")
		{
			mytype=myparse[2].asInt();
			myname=MakeLayer(pfile,mytype,pivotlist[pivotindex]);
			if(2<mytype && mytype<7)
			{
				pivotindex++;
				if(mytype==4 || mytype==5)
            		hasbones=FindABone(pfile);
				else
					hasbones=0;
				pivotlist[pivotindex]=hasbones;
			}
			else
				FindLayerEnd(pfile);
		}
		else if(myparse[1]=="}")
		{
			pivotindex--;
		}
	}
	DeepenLayers();
}

DeepenLayers
{
	layerspace=gset[st_space];  // space between layers;
	mylyrs=lyrdata();
	for(i=mylyrs.size();i>=1;i--)
	{
		lyrsetfg(mylyrs[i]);
		move(<0,0,i*layerspace>);
	}
}

MakeLayer:pfile,ptype,phasbone
{
	pfile.read();    // {
	pfile.read();    // ### generic layer values
	(myname,mypivot,hasbonepar)=GenericLayerValues(pfile,ptype);
	ReadToTransforms(pfile);
	myoffset=ReadTransformOffset(pfile);
	if(ptype==1 || ptype==2)
	{
		setpivot(mypivot+myoffset);
		if(!phasbone || hasbonepar)
		{
			setpivot(mypivot);
			myoffset=<0,0,0>;
		}
		if(ptype==1)
			ReadMesh(pfile,myoffset);
		else if(ptype==2)
			ReadImage(pfile);
	}

	return(myname);
}

FindABone:pfile
{
	LookForSkeleton(pfile);
	mytemp=pfile.read();
	myline=ParseLine(mytemp);
	boneno=myline[2].asInt();
	if(boneno>0)
		return(1);
	return(0);

}

LookForSkeleton:pfile
{
	myline=ParseLine(pfile.read());
	while(myline[1]!="skeleton")
	{
		mytemp=pfile.read();
		myline=ParseLine(mytemp);
	}
	mytemp=pfile.read();
	mytemp=pfile.read();
}

FindLayerEnd:pfile
{
	myline=pfile.read();
	myparse=ParseLine(myline);
	while(myparse[1]!="}")
	{
		myline=pfile.read();
		myparse=ParseLine(myline);
	}
}


GenericLayerValues:pfile,ptype
{
	mylines=ReadGenValues(pfile);

	myline=ParseLine(mylines[3]);
	pivotval=<myline[2].asNum(), myline[3].asNum(),0>;
	boneparline=ParseLine(mylines[4]);
	bonepar=boneparline[2].asInt();
	hasbonepar=0;
	if(bonepar>=0)
		hasbonepar=1;

	temp=parse("\"",mylines[1]);
	glayercount++;
//	myname=temp[2]+"_"+glayercount.asStr();  // make layer name unique
	if(ptype==1||ptype==2)
	{
		mylayers=lyrempty();
		lyrsetfg(mylayers[1]);
		myname=temp[2]+"_"+mylayers[1].asStr();  // make layer name unique
		setlayername(myname);
 	}
	return(myname,pivotval,hasbonepar);
}

ReadGenValues:pfile
{
	mylines[1]=nil;
	for(i=1;i<=15;i++) // read up to empty line.
	{
		mylines[i]=pfile.read();
	}
	return(mylines);
}

SwapString:pname,astring,bstring    //swap bstring for astring
{
	for(i=1;i<=pname.size();i++)
	{
		if(pname[i]==astring)
			pname[i]=bstring;
	}
	return(pname);
}

ReadToTransforms:pfile
{
	myparse=ParseLine(pfile.read());
	while(!pfile.eof() && myparse.size()==2 && myparse[2]!="transforms")
	{
		myparse=ParseLine(pfile.read());
	}
}

ReadTransformOffset:pfile
{
	for(i=1;i<=4;i++)
	{
		myline=pfile.read();
	}
	mystring=ParseLine(myline);
	myval=<mystring[5].asNum(),mystring[6].asNum(),mystring[7].asNum()>;
	return(myval);
}

// ===========================================================================================
// Layer Type 1 -- Meshes

ReadMesh:pfile,poffset
{
	ReadToSection(pfile,"mesh");
	header=ReadMeshHeader(pfile);

	setsurface("Default");
	editbegin();
		mypoints=MakePoints(pfile,poffset);
		if(!mypoints[1])
			addpoint(<0,0,0>);
		mycurves=MakeCurves(pfile,mypoints);
	editend();
	myshapes=ReadShapes(pfile,mycurves);
	mygroups=ReadGroups(pfile,mypoints);
	FreezeMesh();
}

ReadMeshHeader:pfile
{
	for(i=1;i<=10;i++)       // read up to mesh line
	{
		mylines[i]=pfile.read();
	}
	return(mylines);
}

//============================================================
// Points Start

MakePoints:pfile,ppivot
{

	myparse=ParseLine(pfile.read()); //read [
	myparse=ParseLine(pfile.read()); //points <PointNum>

	mycount=myparse[2].asInt();
	mypoints[1]=nil;
	for(i=1;i<=mycount;i++)
	{
		mypointval=ReadPoint(pfile);
     	mypoints[i]=MakePoint(mypointval,ppivot);
	}
	return(mypoints);
}

ReadPoint:pfile
{
	mypoint[1]=GetKeys(pfile);
	mypoint[2]=GetKeys(pfile);
	for(i=3;i<=6;i++)
	{
		mypoint[i]=pfile.read();
	}
	return(mypoint);
}

MakePoint:ppoint,ppivot
{

	mycoordline=ppoint[1][1];
	myx=mycoordline[5]+ppivot.x;
	myy=mycoordline[6]+ppivot.y;
	mypoint=addpoint(<myx,myy,0>);
	return(mypoint);
}

//=======================================================================
// Curves start

MakeCurves:pfile,ppoints
{
	myparse=ParseLine(pfile.read());// curves <curvenum>
	mycount=myparse[2].asInt();
	mycurves[1]=nil;
	for(i=1;i<=mycount;i++)
	{
     	tempcurve=ReadCurve(pfile);
		closedcurve=CloseCurve(tempcurve);
     	mycurves[i]=MakeCurveSegments(closedcurve,ppoints);
     	SmoothCurveEnds(mycurves[i],tempcurve);
	}
	return(mycurves);
}

ReadCurve:pfile
{
	myline=ParseLine(pfile.read());
	mycurve[1][1]=myline[1].asInt(); // point count
	mycurve[1][2]=0;
	if(myline[2]=="true")
		mycurve[1][2]=1;   // curve is closed
	for(i=1;i<=mycurve[1][1];i++)
	{
		myline=ParseLine(pfile.read());
		mycurve[2][i][1]=myline[1].asInt(); // point id
		mycurve[2][i][2]=0;
		if(myline[2]=="true")
			mycurve[2][i][2]=1;   // curve is drawn
		mycurve[2][i][3]=GetKeys(pfile);
	}
	return(mycurve);
}

CloseCurve:pcurve
{
	if(!pcurve[1][2])
		return(pcurve);
	pcurve[2][pcurve[2].size()+1]=pcurve[2][1];
	return(pcurve);
}

MakeCurveSegments:pcurve,ppoints
{
	curvei=1;
	pointi=1;
	for(i=1;i<=pcurve[2].size();i++)
	{
		currpoint=pcurve[2][i];
		pointid=currpoint[1];
		mypointid=ppoints[pointid+1];
    	mycurves[curvei][pointi]=mypointid;
    	sharpness=currpoint[3][1][4];
    	if(sharpness<=gset[st_sharp])
    	{
			curvei++;
			pointi=1;
    		mycurves[curvei][pointi]=mypointid;
		}
		pointi++;
	}
	for(i=1;i<=mycurves.size();i++)
	{
		pointlist=mycurves[i];
		mynewcurves[i]=addcurve(pointlist);
    }
    return(mynewcurves);
}

SmoothCurveEnds:pcurves,pcurve
{
	if(!pcurve[1][2])
		return(pcurve);
	startpoint=pcurve[2][1];
	sharpness=startpoint[3][1][4];
	if(sharpness<st_curvesharpness)
		return(pcurves);

	editend();
	editbegin();
	firstc=pcurves[1];
	lastc=pcurves[pcurves.size()];
	endpoints=polyinfo(lastc);
	startids=polyinfo(firstc);
	startids[1]=endpoints[lastc.pointCount - 1];
	if(firstc==lastc)
		endpoints=startids;
	for(i=1;i<=lastc.pointCount;i++)
    {
		endids[i]=endpoints[i+1];
	}
	endids[lastc.pointCount+1]=startids[2];
	if(firstc!=lastc)
		firstc.setPoints(startids);
	lastc.setPoints(endids);
	editend();
	selmode(USER);
	selpolygon(CLEAR);
	selpolygon(SET,POLYID,firstc);
	toggleCCstart();
	selpolygon(CLEAR);
	selpolygon(SET,POLYID,lastc);
	toggleCCend();
	editbegin();
}


// Curves end
//=======================================================================
// Shapes start

ReadShapes:pfile,pcurves
{
	myshapeheader=ParseLine(pfile.read());
	myshapecount=myshapeheader[2].asInt();
	for(i=1;i<=myshapecount;i++)
	{
		mysurf=ReadShape(pfile,pcurves);
	}
}

ReadShape:pfile,pcurves
{
	myshapeset=ParseLine(pfile.read());
	mytemp=ReadShapeCurves(pfile,pcurves);
	myshape=mytemp[1];
	mycurves=mytemp[2];
	mysurf=ChooseShapeSurface(pfile,mycurves);
	myline=pfile.read();  //reads last ""
	myline=pfile.read();  //reads gap
 	return(mysurf);
}

ReadShapeCurves:pfile,pcurves
{
	myshapepointcount=pfile.read().asInt();
	for(i=1;i<=myshapepointcount;i++)
	{
		myshape[i]=ParseLine(pfile.read());// curve and point
		shapecurves[i]=myshape[i][1].asInt()+1;
	}
	shapecurves.sortA();
	shapecurves.reduce();
	shapecurves.trunc();
	for(i=1;i<=shapecurves.size();i++)
	{
     	curvelist[i]=pcurves[shapecurves[i]];
 	}
 	mytemp[1]=myshape;
	mytemp[2]=curvelist;
	return(mytemp);
}

ChooseShapeSurface:pfile,pcurves
{
	fglayer=lyrfg();
	mymesh=Mesh(0);
	layername=mymesh.layerName(fglayer[1]);
	mysurf=ReadStyle(pfile,layername);
	myline=ParseLine(pfile.read());
	myprestylename=parse("\"",myline[1]);
	if(myprestylename[1])
		mysurf=Surface(myprestylename[1]);
	editbegin();
	for(i=1;i<=pcurves.size();i++)
	{
		p=pcurves[i];                  // p is all LW curves which make up one moho curve.
		for(j=1;j<=p.size();j++)
		{
			if(p[j].surface=="Default")
				polysurface(p[j],mysurf.name);
		}
	}
	editend();
 	return(mysurf);
}

// Shapes end
//=======================================================================
// Groups start

ReadGroups:pfile,ppoints
{
	mygroupheader=ParseLine(pfile.read());
	mygroupcount=mygroupheader[2].asInt();
	for(i=1;i<=mygroupcount;i++)
	{
		mygroups[i]=ReadGroup(pfile,ppoints);
	}
	return(mygroups);
}

ReadGroup:pfile,ppoints
{
	mygroupinfo=ParseLine(pfile.read());
	mygroupname=parse("\"",mygroupinfo[1]);
	mypointno=mygroupinfo[2].asInt();
	myline=ParseLine(pfile.read());
	for(i=1;i<=mypointno;i++)
	{
		pointindex=myline[i].asInt()+1;
		mypoints[i]=ppoints[pointindex];
	}
	editbegin();
	mygroup=VMap(VMSELECT,mygroupname[1],1);
	foreach(p,mypoints)
	{
     	mygroup.setValue(p,1);
	}
	editend();
	return(mygroup);
}

// Groups end
//====================================================================
// Freeze mesh start

FreezeMesh
{
	selmode(USER);
	selpolygon(SET);
	if(gset[st_freez])
	{
		freezecurves();

		mylyr=lyrfg();
		lyrsetfg(mylyr[1]+1);
		lyrsetfg(mylyr[1]);
		selmode(USER);
		selpolygon(CLEAR);
		selpolygon(SET);

		if(gset[st_tripl])
			triple();

		AlignNormals();
	}
}

AlignNormals
{

		selmode(USER);
		selpolygon(SET);

		editbegin();
			if(polygons)
			{
				mypols;
				i=1;
        		foreach(p,polygons)
        		{
             		mynorm=polynormal(p);
             		if(mynorm!=nil && mynorm.z>0)
             		{
             				mypols[i]=p;
             				i++;
             			}
//     				}
				}
			}
		editend();
		if(mypols)
		{
			selmode(DIRECT);
			selpolygon(CLEAR);
			selpolygon(SET,POLYID,mypols);
			flip();
		}

}

// Freeze end
//========================================================================
// Layer Type 2 Images
ReadImage:pfile
{
	ReadToSection(pfile,"image");
	myimageline=parse("\"",pfile.read());
	myfile=myimageline[2];
	myset[1]=FindImage(myfile,pfile); // image
	myset[2]=ParseLine(pfile.read());        // avi has alpha
	myset[3]=ParseLine(pfile.read());        // size
	MakeImage(myset);
}

FindImage:pimagef,pfile
{
	myimage=nil;
	if(!pimagef)
		return;
	dirsplit=split(pfile.name());
	// Look in moho dir
	compfile=dirsplit[1]+dirsplit[2]+pimagef;
	myimage=loadimage(pimagef);
	if(!myimage)
	{
		// try Images
		dirsplit=split(getdir(IMAGESDIR));
		compfile=dirsplit[1]+dirsplit[2]+pimagef;
		myimage=loadimage(compfile);
	}
	if(!myimage)
	{
		dirsplit=split(pfile.name());
		// Look in moho dir
		compfile=dirsplit[1]+dirsplit[2]+pimagef;
		myimage=loadimage(compfile);
	}
	if(!myimage)
	{
		dirsplit=split(pfile.name());
		// Look in moho dir
		compfile=dirsplit[1]+dirsplit[2];
   		myname=getfile("Please select image:",pimagef,compfile,1);
		myimage=loadimage(myname);
	}
	return(myimage);
}

MakeImage:pset
{
	mylayer=lyrfg();
	mysize=<pset[3][2].asNum(),pset[3][3].asNum(),0>;
	surfname=pset[1].name+"_"+mylayer[1].asStr();
	setsurface(surfname);
	editbegin();
	mysegnum=gset[st_image];
	mypoints=MakeImPoints(mysize,mysegnum);
	mypolys=MakeImPolys(mypoints,mysegnum);
	FixCorners(mypoints,mysegnum);
	editend();
	togglepatches();
	SetupImageSurf(surfname,pset);
}

MakeImPoints:psize,psegnum
{
	start=<0,0,0>-psize/2;
	increment=psize/psegnum;

	vmap=VMap(VMTEXTURE,"UV Texture",2);         // for uv map.
	uvincrement=1.0/psegnum;

	for(i=0;i<=psegnum;i++)
	{
		for(j=0;j<=psegnum;j++)
		{
			mypoint=addpoint(<start.x+j*increment.x,start.y+i*increment.y,0>);
			mypoints[i+1][j+1]=mypoint;
			uvvalue=@j*uvincrement,i*uvincrement@;
			vmap.setValue(mypoint,uvvalue);
		}
	}
	return(mypoints);
}

MakeImPolys:ppoints,psegnum
{
	for(i=1;i<=psegnum;i++)
	{
		for(j=1;j<=psegnum;j++)
		{
			pointset[1]=ppoints[i][j];
			pointset[2]=ppoints[i+1][j];
			pointset[3]=ppoints[i+1][j+1];
			pointset[4]=ppoints[i][j+1];
			mypolys[i][j]=addpolygon(pointset);
		}
	}
	return(mypoints);
}

FixCorners:ppoints,psegnum
{
	wmap=VMap(VMSUBPATCH);
	wmap.setValue(ppoints[1][1],1);
	wmap.setValue(ppoints[1][psegnum+1],1);
	wmap.setValue(ppoints[psegnum+1][1],1);
	wmap.setValue(ppoints[psegnum+1][psegnum+1],1);
}

SetupImageSurf:pname,pset
{
	mymesh=Mesh(0);
	mycommand="Surf_SetSurf \""+pname+"\" \""+mymesh.name+"\"";
	CommandInput(mycommand);
	mycommand="Surf_SetInt \"BaseColor\" 2";
	CommandInput(mycommand);
	mysurf=Surface(pname);
	mysurf.setValue(SURFLUMI,1);
	mysurf.setValue(SURFDIFF,0);
	mysurf.setValue(SURFSIDE,1);

	mytext=mysurf.getTexture(SURFCOLR);
	myimage=pset[1];
	SetupImage(mytext,myimage);
}

SetupImage:ptext,pimage
{
	mymap=VMap("UV Texture");
	mytextlyr=ptext.addLayer(TXTRIMAGE);
	mytextlyr.setValue(TXLRPROJECT,TXPJUVMAP);
	mytextlyr.setValue(TXLRIMAGE,pimage);
	mytextlyr.setValue(TXLRVMAP,mymap);
}
//========================================================================

SumOffset
{
	mypivot=<0,0,0>;
	for(i=1;i<=gpivotindex;i++)
	{
    	mypivot=mypivot+gpivotlist[i];
	}
	return(mypivot);
}

//===============================================================
// Start Keys

GetKeys:qfile
{
	mykeys=ReadKeys(qfile);
	actionkeys=ReadActions(qfile,qisstring);
	return(mykeys);
}

ReadKeys:qfile     // reads everything except the last ]
{
	isstring=0;
	myline=qfile.read();// open [
	myline=qfile.read();// keys count
	mykeystring=ParseLine(myline);
	mykeynum=mykeystring[2].asInt();
	for(i=1;i<=mykeynum;i++)
	{
		mylines[i]=qfile.read();
	}
	for(i=1;i<=mykeynum;i++)
	{
		mytemp=ParseLine(mylines[i]);
		mykeys[i][1]=mytemp[1].asNum();   // frame no
		mykeys[i][2]=mytemp[2].asNum();   // key type
		mykeys[i][3]=mytemp[3].asNum();
		mykeys[i][4]=mytemp[4].asNum();
	}
	parseline=ParseLine(mylines[1]);
	if(mylines[1].contains("\""))
		mykeys=MakeStringKeys(mykeynum,mykeys,mylines);
	else if(parseline[5]=="true" || parseline[5]=="false")
		mykeys=MakeBoolKeys(mykeynum,mykeys,mylines);
	else
		mykeys=MakeNumKeys(mykeynum,mykeys,mylines);
	return(mykeys);
}

MakeStringKeys:pkeynum,pkeys,plines
{
	for(i=1;i<=pkeynum;i++)
	{
		stringparse=parse("\"",plines[i]);
		if(stringparse.size()>1)
			pkeys[i][5]=stringparse[2];
		else
			pkeys[i][5]=nil;
	}
	return(pkeys);
}

MakeBoolKeys:pkeynum,pkeys,plines
{
	for(i=1;i<=pkeynum;i++)
	{
		parseline=ParseLine(plines[i]);
		pkeys[i][5]=StringToBool(parseline[5]);
	}
	return(pkeys);
}

MakeNumKeys:pkeynum,pkeys,plines
{
	for(i=1;i<=pkeynum;i++)
	{
		parseline=ParseLine(plines[i]);
		for(j=5;j<=parseline.size();j++)
		{
			pkeys[i][j]=parseline[j].asNum();
		}
	}
	return(pkeys);
}

// End Get keys
//======================================================================================
// Read Actions
ReadActions:qfile,qisstring  // reads the last ] or the first actions
{
	myline=ParseLine(qfile.read());// close ] or actions
	if(myline[1]=="]")
		return(nil);

	acount=myline[2].asInt();

	for(t=1;t<=acount;t++)
	{
		myactions[t]=ReadAction(qfile,qisstring);
	}
	myline=ParseLine(qfile.read());// close ]
	return(myactions);
}

ReadAction:qfile,qisstring
{

	myname=parse("\"",qfile.read());
	action[1]=myname[2];//Action name
	myline=ParseLine(qfile.read());
	while(myline[1]!="]")
	{
		myline=ParseLine(qfile.read());
	}
//	action[2]=GetKeys(qfile);
   	return(action);
}

//========================================================================================

MakeKeys:pchannel,pkeys,ppos,poffset=0
{
	myfps=Scene().fps;
	for(i=1;i<=pkeys.size();i++)
	{
		keytime=pkeys[i][st_keyt]/myfps;
		keyval=pkeys[i][ppos];
		if(mykey=pchannel.keyExists(keytime))
			pchannel.setKeyValue(mykey,keyval+poffset);
		else
			mykey=pchannel.createKey(keytime,keyval+poffset);
		pchannel.setKeyTension(mykey,1.0);
	}

	if(poffset!=0)
	{
		mykey=pchannel.keyExists(0);
		keyval=pchannel.getKeyValue(mykey);
		pchannel.setKeyValue(mykey,keyval-poffset);
		mykey=pchannel.keyExists(1/myfps);
		if(!mykey)
		{
			mykey=pchannel.createKey(1/myfps,keyval);
			pchannel.setKeyTension(mykey,1.0);
		}
	}
}

ParseLine:pstring
{
	if(pstring==nil)
	{
		mystring[1]=nil;
		return(mystring);
	}
	mysize=pstring.size();
	mystring=pstring;
	i=1;
	while(i<=mysize && pstring[i].isCntrl())
	{
    	i++;
	}
	mystring=strright(pstring,(mysize - i + 1));
	mystring=parse(" ",mystring);
	return(mystring);
}

StringToBool:pstring
{
	mybool=0;
	if(pstring=="true")
		mybool=1;
	return(mybool);
}

ReadToSection:pfile,pstring
{
	myline=pfile.read();
	myparse=ParseLine(myline);
	while(!pfile.eof())
	{
		if(myparse.size()>1 && myparse[1]=="###" && myparse[2]==pstring)
			return;
		myline=pfile.read();
		myparse=ParseLine(myline);
	}
}

FindSegmentStart:pfile,pstring,pendstring="MGImportMohoString"
{
	myline=pfile.read();
	while(myline!=pstring && !pfile.eof() && myline!=pendstring)
	{
		myline=pfile.read();
	}
	return(myline);
}
